library IEEE;
use IEEE.std_logic_1164.all;

entity four_bit_full_adder is
  port (a,b : in STD_LOGIC_VECTOR(3 downto 0);
        cin : in STD_LOGIC;
        s   : out STD_LOGIC_VECTOR(3 downto 0);
        cout: out STD_LOGIC);
end four_bit_full_adder;

architecture Behaviour of four_bit_full_adder is

  component one_bit_full_adder
    port (a,b,cin : in STD_LOGIC;
          s, cout : out STD_LOGIC);
   end component;

  signal cout_0, cout_1, cout_2 : STD_LOGIC;

begin

  one_bit_full_adder_0: one_bit_full_adder port map(
   				 a => a(0),
				 b => b(0),
				 cin => cin,
				 s => s(0),
				 cout => cout_0);

  one_bit_full_adder_1: one_bit_full_adder port map(
   				 a => a(1),
				 b => b(1),
				 cin => cout_0,
				 s => s(1),
				 cout => cout_1);

  one_bit_full_adder_2: one_bit_full_adder port map(
   				 a => a(2),
				 b => b(2),
				 cin => cout_1,
				 s => s(2),
				 cout => cout_2);

  one_bit_full_adder_3: one_bit_full_adder port map(
   				 a => a(3),
				 b => b(3),
				 cin => cout_2,
				 s => s(3),
				 cout => cout);
end Behaviour;
